##
## ASPj.pm	- Perl module library for Active Server Pages jl10n version.
##		This module works without XS nor Apache mod_perl.
##		You can use this module on rental servers (which
##		supports CGI).
##
## Author: Masanao Izumo: <mo@goice.co.jp>
## Version 1.3.1
## LastModified: 2000, 5/27
##
##
## ܥ⥸塼ϡʲΥݥꥷ򸵤˺ޤ
## 󥿥륵оǼ¹ԤΤǡXSApache ⥸塼벽mod_perl 
##   ɬפȤʤ perl ư롣CGI ܥ⥸塼ɤ
##   ASP ե򤷤Ƽ¹Ԥޤ
## Perl Υѥå + jcode.pl ʳΥ⥸塼
##   ɬפȤޤ
## ASP ե Shift_JIS ɤǽ񤱤뤳ȡ餯Shift_JIS 
##   ۤȥ֥뤬Ǥ⾯ʤƺѤࡣ
## CPAN  Win32::ASP, Apache::ASP Ȥθߴ̵롣
##   䤬Ȥ䤹褦 API ¤뵤Ǥޤ
##
## ChangeLog:
## Version 1.3.1, (2000, 5/27)
## - ѿ˴ؤ뽤
## Version 1.3.0, (2000, 5/24)
## - Х륪֥Ȥ local ˤ
## - my Τ bless 褦ˤ
## - Ҥ NestDepth ȽǤ褦ˤ
## - ʸ顼ΥåФ褦ˤ
## - StripFirstSpace ɲä
## Version 1.2.0, (2000, 5/17)
## - $Request->Form($name, $value); ͤ򥻥åȤ뤳Ȥ
##   Ǥ褦ˤ
## - $Request->Form($name); εͤϾ˥顼ͤˤ
##   Ĥ̾ʣͤƤ "\0"  join 롣
## - perl 5.6.0 ǥפХľ 
## - STDOUT Хåեʤ褦ˤ
## - $Server->URLDecode($string) ɲäURLEncode Τ򸵤᤹
## Version 1.1.1
## - Bug fix


package ASPj;

use Carp;
use CGI;
require 'jcode.pl';

#use strict;
use vars qw(%jcodeMap $params $this
	    $Response $Application $Request $Server
	    *ASPOUT *SAVEOUT *EXIT_ASP);

%jcodeMap = ('sjis' => 'sjis',
	     'Shift_JIS' => 'sjis',
	     'SHIFT_JIS' => 'sjis',
	     'shift_jis' => 'sjis',

	     'euc' => 'euc',
	     'EUC' => 'euc',
	     'x-euc' => 'euc',

	     'jis' => 'jis',
	     'iso-2022-jp' => 'jis',
	     'ISO-2022-JP' => 'jis');

# $asp = new ASPj;
# $query = $asp->{CGI};
sub new {
    my $class = shift;
    my %this = (
	'DocumentEncoding' => 'Shift_JIS',
	'DocumentNewline' => "\r\n",
	'OutputRedirect' => undef,
	'ContentType' => 'text/html',
	'Pragma' => undef,
	'CGI' => &CGIQuery(@_),
	'LockFile' => "$0.lock",
	'Filename' => undef,
	'NestDepth' => 0,
	'StripFirstSpace' => 1,
	);
    bless \%this;
}
sub DESTROY {
    shift->{CGI} = undef;
}

# $asp->output('filename.asp', \%params);	%params is exported to ASP
sub output {
    local $this = shift;
    my $save_filename = $this->{Filename};
    $this->{Filename} = shift;
    $params = shift;
    my $output_redirect = $this->{OutputRedirect};
    my $jc = ($jcodeMap{$this->{DocumentEncoding}} || 'sjis');
    my($page, $prog, $text, $perl, $nl_count, $org_handle, $org_flush);
    local(*EXIT_ASP, *ASPOUT, *SAVEOUT);
    local($Response, $Application, $Request, $Server);

    $this->{NestDepth}++;

    $Response = ASPj::Response->new($this);
    $Application = ASPj::Application->new($this);
    $Request = ASPj::Request->new($this);
    $Server = ASPj::Server->new($this);

    if(ref $this->{Filename}) {
	my $f = $this->{Filename};
	local($/); $page = <$f>;
    } else {
	open(SAVEOUT, $this->{Filename}) || croak "$this->{Filename}: $!\n";
	{ local($/); $page = <SAVEOUT>; }
    }

    { # expand #include
	local($/);
	$page =~ s/<!--#include\s+file\s*=\s*\"?([^\" \r\n\t]*)\"?\s*--\s*>/
	{
	    open(SAVEOUT, $1) || croak "$1: $!\n";
	    <SAVEOUT>;
	}/eg;		#"...
    }
    close SAVEOUT;

    if($jc ne 'euc') {
	&jcode::convert(\$page, 'euc', $jc);
    }
    $page =~ s/\r\n|[\r\n]/\n/g;
    $page =~ s/^\#\!.*//;
    $page =~ s/^(\s*<\%\@\s*language\s*=\s*\"?perlscript\"?\s*\%>\s*)//i; #"...

    $nl_count = (($nl_count = $1) =~ tr/\n//);

    if($output_redirect) {
	open(SAVEOUT, ">&STDOUT") || croak "dup: $!\n";
	open(STDOUT, ">$output_redirect") || croak "$output_redirect: $!\n";
	$Response->{Header} = 1;
    }

    # generate eval code
    $prog = "EXIT_ASP: {";
    $prog .= (";\n" x $nl_count);
    while($page =~ s/^(.*?)\<\%(.*?)\%\>//so) {
	($text, $perl) = ($1, $2);
	if($text ne '') {
	    $text =~ s/([\\\'])/\\$1/g;
	    $prog .= "\$Response->Write('$text');";
	}
	if($perl =~ s/^\s*=\s*//s) {
	    $prog .= "\$Response->Write(\$Server->HTMLEncode($perl));";
	} else {
	    $perl =~ s/^\s*\#.*//;
	    $prog .= $perl . ';';
	}
    }
    if($page ne '') {
	$page =~ s/\'/\\\'/g;
	$prog .= "\$Response->Write('$page');";
    }
    $prog .= '}';
    $prog =~ /(.*)/s;
    $prog = $1;

    if($this->{NestDepth} == 1) {
	$org_flush = $|;
	$org_handle = select(STDOUT);
	$| = 1;
    }

    tie *ASPOUT, 'ASPj', $this;		# redirect print & printf
    select ASPOUT;
    &__call(\$prog);
    $Response->Flush if $Response;
    untie *ASPOUT if tied *ASPOUT;

    if($this->{NestDepth} == 1) {
	select $org_handle;
	$| = $org_flush;
    }

    if($output_redirect) {
	open(STDOUT, ">&SAVEOUT") || croak "dup: $!\n";
	close SAVEOUT;
    }
    $this->{Filename} = $save_filename;
    $this->{NestDepth}--;
}

##
## Private Methods...
##

sub CGIQuery {
    my $query = new CGI(@_);
    my($value, $name, @values);
    foreach $name ($query->param) {
	@values = $query->param($name);
	foreach $value (@values) {
	    if(!&ASPj::jcodesub::convert(\$value, 'euc', undef, 'z')) {
		my $hexdump = unpack('H*', $value);
		select STDOUT;
		print $query->header;
		$| = 1;	# flush
		print &jcode::sjis(<<"EOF", 'euc');
<HTML>
<HEAD>
<meta http-equiv="Content-Type" content="text/html; charset=Shift_JIS">
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<TITLE>CGI Fatal Error</TITLE>
</HEAD>
<BODY BGCOLOR="#000000" TEXT="#FFFF00">
<H1>CGI Fatal Error</H1>
<P>
ԥ塼ǽǤʤʸޤޤƤޤ
ʸᡢλޤ<br>
ΥڡʸΤޤƤʤɤ<br>
ȤΥ֥饦ܸбƤ뤫ɤ<br>
¸ʸ(ʤ)ȤƤʤɤ<br>
ʤɤ򤴳ǧ
</P>
<P>
ʸʸ 16ʿ: <CODE>$hexdump</CODE>
</P>
</BODY>
</HTML>
EOF
		exit 0;
	    }
	}
	$query->param($name, @values);
    }
    $query;
}

# evaulate ASP action.
sub __call {
    my $prog = shift;
    local $SIG{__DIE__} = sub {
	my $f = $ASPj::this->{Filename};
	my $redirect = $ASPj::this->{OutputRedirect};
	untie *ASPOUT if tied *ASPOUT;
	if($redirect) {
	    select SAVEOUT;
	} else {
	    select STDOUT;
	}
	$| = 1;
	if(!$ASPj::Response->{Header}) {
	    my $cgi = $ASPj::Response->{ASP}->{CGI};
	    print $cgi->header('-Pragma' => 'no-cache',		# for Std.
			       '-Cache-control' => 'no-cache');	# for IE
	    print <<"EOF";
<HTML>
<HEAD>
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<TITLE>CGI Fatal Error</TITLE>
</HEAD>
<BODY BGCOLOR="#000000" TEXT="#FFFF00">
<H1>CGI Fatal Error</H1>
<PRE>
$f: @_
</PRE>
</BODY>
</HTML>
EOF
	} else {
	    print "\n<P>\nCGI Fatal Error: $f: ", @_, "</P>\n";
	}
	exit 0;
    };
#print STDOUT $$prog; exit 0;
    eval $$prog;
    die $@ if $@;
}


sub TIEHANDLE { $_[1]; }
sub PRINT {
    my $this = shift;
    $ASPj::Response->Write(@_);
}
sub PRINTF {
    my $this = shift;
    $ASPj::Response->Write(sprintf shift, @_);
}



# $Response = ASPj::Response->new($asp);
package ASPj::Response;
sub new {
    my $class = shift;
    my $asp = shift;
    my %this = (
	'.Buffer' => '',	# buffer pool
	'Buffer' => 0,
	'ASP' => $asp,
	'Header' => 0,
	'OutputBytes' => 0,
	);
    bless \%this;
}
sub DESTROY {
    shift->{ASP} = undef;
}

# $Response->Write('foo', 'bar', 'baz', ...);
sub Write
{
    my $this = shift;
    my $nl = $this->{ASP}->{DocumentNewline};
    my $code = ($ASPj::jcodeMap{$this->{ASP}->{DocumentEncoding}} || 'sjis');
    my $val;

    for(@_) {
	$val = $_;
	&jcode::convert(\$val, $code, 'euc');
	$val =~ s/\r\n|[\r\n]/$nl/g;
	&ASPj::Response::WriteRaw(\$val);
    }
}

# $Response->Flush;
sub Flush
{
    my $this = shift;
    my $buff = $ASPj::Response->{'.Buffer'};

    $ASPj::Response->{'.Buffer'} = '';
    $ASPj::Response->{Buffer} = 0;
    &ASPj::Response::WriteRaw(\$buff);
}

sub Clear {
    $ASPj::Response->{'.Buffer'} = '';
}

sub Redirect {
    my $this = shift;
    untie *ASPOUT if tied *ASPOUT;
    select STDOUT;
    $ASPj::this->output(@_);
    last EXIT_ASP;
}

sub WriteRaw {
    local(*_) = @_;

    if($ASPj::Response->{Buffer}) {
	$ASPj::Response->{'.Buffer'} .= $_;
    } else {
	if(!$ASPj::Response->{Header}) {
	    $ASPj::Response->{Header} = 1;
	    print STDOUT $ASPj::Response->{ASP}->{CGI}->header;
	}
	if($ASPj::Response->{OutputBytes} == 0 &&
	   $ASPj::this->{StripFirstSpace}) {
	    s/^\s+//;
	}
	$ASPj::Response->{OutputBytes} += length;
	print STDOUT;
    }
}

# $Response->Cookies($name, [$key,] $value)
sub Cookies {
    # TODO
    shift->{ASP}->{CGI}->cookie(@_);
}

package ASPj::Application;
sub new {
    my $class = shift;
    my $asp = shift;
    my %this = (
	'ASP' => $asp,
	'LOCK' => undef,
	);
    bless \%this;
}
sub DESTROY {
    shift->{ASP} = undef;
}

# $Application->Lock;
sub Lock {
    my $this = shift;
    my $fiz = "$this";
    my $file = $this->{ASP}->{LockFile};
    open($fiz, ">>$file") || die "$file: $!\n";
    flock($fiz, 2);
    $this->{LOCK} = $fiz;
}

# $Application->Unlock;
sub Unlock {
    my $this = shift;
    my $fiz = $this->{LOCK};
    close($fiz);
    $this->{LOCK} = undef;
}

package ASPj::Request;
sub new {
    my $class = shift;
    my $asp = shift;
    my %this = ('ASP' => $asp);
    bless \%this;
}
sub DESTROY {
    shift->{ASP} = undef;
}

# $value = $Request->Form($name);
# @values = $Request->Form($name);
# $hash_ref = $Request->Form;
sub Form {
    my $cgi = shift->{ASP}->{CGI};
    if(@_) {
	return join("\0", $cgi->param(@_));
#	return (wantarray ? $cgi->param(@_) : scalar($cgi->param(@_)));
    }
    my %table;
    for($cgi->param) {
	if(exists $table{$_}) {
	    $table{$_} .= "\0" . $cgi->param($_);
	} else {
	    $table{$_} = $cgi->param($_);
	}
    }
    \%table;
}

# $Request->QueryString($name)
*QueryString = *Form; # aliasing

# $Request->ServerVariables($name)
sub ServerVariables {
    my $this = shift;
    @_ ? $ENV{$_[0]} : \%ENV;
}


package ASPj::Server;
sub new {
    my $class = shift;
    my $asp = shift;
    my %this = ('ASP' => $asp);
    bless \%this;
}
sub DESTROY {
    shift->{ASP} = undef;
}

# $Server->HTMLEncode($string)
sub HTMLEncode {
    my $this = shift;
    local $_ = shift;
    s/&/&amp;/g;
    s/\"/&quot;/g;		#"...
    s/>/&gt;/g;
    s/</&lt;/g;
    $_;
}

# $Server->URLEncode($string)
sub URLEncode {
    my $this = shift;
    local $_ = shift;
    s/([^a-zA-Z0-9_\-.])/'%' . unpack('H2', $1)/eg;
    $_;
}

# $Server->URLDecode($string)
sub URLDecode {
    my $this = shift;
    local $_ = shift;
    tr/+/ /;
    s/%([0-9A-F][0-9A-F])/chr(hex($1))/egi;
    $_;
}

# $Server->URL($url, \%params)
sub URL {
    my $this = shift;
    my($url, $p) = @_;
    $url . '?' . join('&', map {
	$this->URLEncode($_) . '=' . $this->URLEncode($p->{$_})
	} keys %$p);
}



##
## JCode support
##
##
## jcodesub.pl
##
## Version 2.0.1
## Last modified: May 9 2000
## Support library for jcode.pl.  This library fixes the probrem of
## original conversion of jcode.pl.
## (C) Office Orange <mo@office-orange.co.jp>
##
package ASPj::jcodesub;
use vars qw(%hz_table %zh_table);

sub convert {
    local(*_, $ocode, $icode, $opt) = @_;
    $icode = &getcode(*_) unless $icode;
    if(!defined $icode) {
	return undef unless $opt =~ /f/;
	&jcode::convert(*_, $ocode);
    } elsif($icode eq 'jis') {
	&jis_pre(*_);
	&jcode::convert(*_, $ocode, $icode, $opt);
    } elsif($icode eq 'sjis') {
	&sjis_pre(*_);
	&jcode::convert(*_, $ocode, $icode, $opt);
    } elsif($icode eq 'euc') {
	&jcode::convert(*_, $ocode, $icode, $opt);
    }
    return 1;
}

sub getcode {
    local(*_) = @_;
    return 'ascii' if &isascii(*_);
    return 'jis' if &isjis(*_);
    return 'sjis' if &issjis(*_);
    return 'euc' if &iseuc(*_);
    return undef;
}

sub isascii {
    local(*_) = @_;
    /^[\011-\015\040-\176]*$/;
}

sub iseuc {
    local(*_) = @_;
#    /^([\011-\015\040-\176]|[\241-\376][\241-\376]|\216[\241-\337]|\217[\241-\376][\241-\376])*$/;
    /^([\011-\015\040-\176]|[\241-\376][\241-\376]|\216[\241-\337])*$/;
}

sub issjis {
    local(*_) = @_;
    /^([\011-\017\040-\176\240-\337]|[\201-\237\340-\374][\100-\176\200-\374])*$/;
}

sub isjis {
    local(*_) = @_;
    /^[\011-\017\040-\176]*(($jcode::re_jp|$jcode::re_asc|$jcode::re_kana)[\011-\017\040-\176]*)*$/;
}

sub sjis_pre {
    local(*_) = @_;
    s/\016([^\017]*)\017?/&_sjis_pre($1)/eg;
}

sub _sjis_pre {
    local($_) = @_;
    tr/\041-\137/\241-\337/;
    $_;
}

sub jis_pre {
    local(*_) = @_;
    local($lastesc);
    $_ = $jcode::esc_asc . $_;
    s/($jcode::re_jp|$jcode::re_asc|$jcode::re_kana)([^\e]*)/&_jis_pre($1,$2)/geo;
    s/^($jcode::re_asc)//;
    if($lastesc =~ /$jcode::re_kana|$jcode::re_jp/) {
	$_ .= $jcode::esc_asc;
    }
}
sub _jis_pre {
    local($esc, $_) = @_;
    s/\016([^\017]*)\017?/$jcode::esc_kana . $1 . $esc/eg;
    $lastesc = $esc;
    $esc . $_;
}

%hz_table = split(/\s+/, <<'END_TABLE');
!  "  #  $  %  &  '  (  )  *  +  ,  -  . 
/  0  1  2  3  4  5  6  7  8  9  :  ;  < 
=  >  ?  @  A  B  C  D  E  F  G  H  I  J 
K  L  M  N  O  P  Q  R  S  T  U  V  W  X 
Y  Z  [  \  ]  ^  _  `  a  b  c  d  e  f 
g  h  i  j  k  l  m  n  o  p  q  r  s  t 
u  v  w  x  y  z  {  |  }  ~ 
END_TABLE
$hz_table{' '} = '';

%zh_table = split(/\s+/, <<'END_TABLE');
 ,  .  ,  .  :  ;  ?  !  "  '  `  ^  ^ 
_  -  -  -  /  \  ~  ||  |  `  '  "  "  ( 
)  [  ]  [  ]  {  }  <  >  <<  >>  +  -  x
 =  <  >  '  ''  $  %  #  &  *  @  #  0  1
 2  3  4  5  6  7  8  9  A  B  C  D  E  F
 G  H  I  J  K  L  M  N  O  P  Q  R  S  T
 U  V  W  X  Y  Z  a  b  c  d  e  f  g  h
 i  j  k  l  m  n  o  p  q  r  s  t  u  v
 w  x  y  z  -  |  -  |
END_TABLE
$hz_table{''} = ' ';

sub hz {
    local(*_) = @_;
    s/([\011-\015\040-\176])/$hz_table{$1} eq '' ? $1 : $hz_table{$1}/eg;
}

sub zh {
    local(*_) = @_;
    s/([\241-\376][\241-\376]|\216[\241-\337])/$zh_table{$1} eq '' ? $1 : $zh_table{$1}/eg;
}

1;
